package phonix;

import java.util.ArrayList;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.GridData;

public class ComboCheckbox extends Composite {
	private Button cb;

	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 */
	public ComboCheckbox(Composite parent, int style, ArrayList<String> email,
			ArrayList<Button> buttons) {
		super(parent, SWT.NONE);
		GridLayout gridLayout = new GridLayout();
		gridLayout.makeColumnsEqualWidth = false;
		gridLayout.verticalSpacing = 5;
		gridLayout.numColumns = 2;
		setLayout(gridLayout);
		for (String s : email) {
			cb = new Button(this, SWT.CHECK);
			cb.setText(s);
			cb.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			buttons.add(cb);

		}

		this.layout();
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
