package phonix;

public class Country implements Comparable<Country>{
private String code;
private String name;

public String getCode() {
	return code;
}
public void setCode(String code) {
	this.code = code;
}
public String getName() {
	return name;
}
public void setName(String name) {
	this.name = name;
}
@Override
public int hashCode() {
	final int prime = 31;
	int result = 1;
	result = prime * result + ((code == null) ? 0 : code.hashCode());
	result = prime * result + ((name == null) ? 0 : name.hashCode());
	return result;
}
@Override
public boolean equals(Object obj) {
	if (this == obj) {
		return true;
	}
	if (obj == null) {
		return false;
	}
	if (!(obj instanceof Country)) {
		return false;
	}
	Country other = (Country) obj;
	if (code == null) {
		if (other.code != null) {
			return false;
		}
	} else if (!code.equals(other.code)) {
		return false;
	}
	if (name == null) {
		if (other.name != null) {
			return false;
		}
	} else if (!name.equals(other.name)) {
		return false;
	}
	return true;
}
public Country(String code, String name) {
	super();
	this.code = code;
	this.name = name;
}
@Override
public int compareTo(Country o) {
	return name.compareTo(o.name);
}

}
