package phonix;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class SVGSkeleton {
public void createSVG(Person p,String mode){
	String loco=null;
	if(mode.equals("VIP")){
		loco="misc/phonix.svg";
	}
	if(mode.equals("POST")){
		loco="misc/post.svg";
	}
	BufferedReader in =new BufferedReader(new InputStreamReader( this.getClass().getClassLoader()
            .getResourceAsStream(loco)));
	
	String s=null;
	StringBuffer sb=new StringBuffer();
	try {
		while((s=in.readLine())!=null){
			sb.append(s);
		}
		in.close();
	} catch (IOException e) {
		e.printStackTrace();
	}
	String a=sb.toString();
	a=a.replaceAll("NEVEM", p.getName());
	a=a.replaceAll("CIMEM", p.getAddress());
	a=a.replaceAll("IRANYITOSZAM", p.getZIP());
	a=a.replaceAll("VAROS", p.getPlace());
	if(p.getNumber().size()>0){
		a=a.replaceAll("TELEFONSZAM", p.getNumber().get(0));
	}else{
		a=a.replaceAll("TELEFONSZAM", "-");
	}
	
	if(p.getEmail().size()>0){
		a=a.replaceAll("EMAIL", p.getEmail().get(0));
	}else{
		a=a.replaceAll("EMAIL", "-");
	}
	a=a.replaceAll("HONLAP", p.getWebsite());
	a=a.replaceAll("ORSZAG", PUtils.codeToCountry(p.getCountry()));
	File f=new File(System.getProperty("user.home")+File.separatorChar+p.getName()+".svg");
	try {
		PrintStream ps=new PrintStream(new FileOutputStream(f));
		ps.println(a);
		ps.close();
	} catch (FileNotFoundException e) {
		e.printStackTrace();
	}
	
	
}
}
