package phonix;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.printing.PrintDialog;
import org.eclipse.swt.printing.Printer;
import org.eclipse.swt.printing.PrinterData;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Combo;

/**
 * @author minthaka
 *
 */
/**
 * @author minthaka
 *
 */
/**
 * @author minthaka
 *
 */
/**
 * @author minthaka
 * 
 */
public class Searcher extends Shell {
	private Label lblNewLabel;
	private static Text text;
	private Group grpWhereToSearch;
	private Button nameRB;
	private Button emailRB;
	private Button placeRB;
	private Button addressRB;
	private Button zipRB;
	private Button numberRB;
	private Button entireRB;
	private Composite composite;
	private Label lblNewLabel_2;
	private Label lblNewLabel_3;
	private List nameList;
	private List dataList;
	private Button bookletCB;
	private Button printListB;
	private Label hitNrL;
	private Button detailsB;
	private Button closeB;
	private static Searcher shell;
	private static DatabaseConnector connection;
	private static String oszlop = "*";
	private static ArrayList<Person> persi = new ArrayList<>();
	private static StringBuffer sb = new StringBuffer();
	private static boolean booklet = false;
	private static int order = 0;
	private static ArrayList<Integer> namer = new ArrayList<>();
	private Menu menu;
	private MenuItem mntmNewItem;
	private MenuItem mntmNewItem_1;
	private static Humanoid px = new NullPerson();
	private MenuItem mntmNewItem_2;
	private MenuItem mntmNewItem_3;
	private MenuItem mntmNewItem_4;
	private MenuItem mntmNewItem_5;
	private Button websiteRB;
	private MenuItem envelopeMenu;
	private MenuItem mntmNewItem_6;
	private static String xcard;
	private Button countryRB;
	private MenuItem mntmNewItem_7;
	private MenuItem mntmNewItem_8;
	private Button btnRadioButton;
	private Combo combo;
	private Composite composite_1;
	private Button btnNewButton;

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static Humanoid go(DatabaseConnector con, String contact) {
		connection = con;
		try {
			Display display = Display.getDefault();
			shell = new Searcher(display);
			shell.setLocation((Display.getCurrent().getBounds().width - shell
					.getBounds().width) / 2,
					(Display.getCurrent().getBounds().height - shell
							.getBounds().height) / 2);
			if (contact != null)
				text.setText(contact);
			text.setSelection(0, text.getText().length());
			shell.open();
			shell.layout();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return px;
	}

	/**
	 * Create the shell.
	 * 
	 * @param display
	 */
	public Searcher(Display display) {
		super(display, SWT.SHELL_TRIM);
		setLayout(new GridLayout(2, false));

		lblNewLabel = new Label(this, SWT.NONE);
		lblNewLabel.setText(PUtils.UTF8("LABEL_PHRASE"));

		text = new Text(this, SWT.BORDER);
		text.addMouseListener(new MouseAdapter() {
			@Override
			// Perform quicksearch
			public void mouseDown(MouseEvent e) {
				if (!text.getText().equals("")) {
					doSearch(text.getText());
				} else {
					nameList.removeAll();
					hitNrL.setText(PUtils.UTF8("STRING_FOUND")
							+ nameList.getItemCount() + " "
							+ PUtils.UTF8("STRING_HITS"));
					persi.clear();
				}
			}
		});

		text.addKeyListener(new KeyAdapter() {
			@Override
			// Perform quicksearch
			public void keyReleased(KeyEvent e) {
				if (!text.getText().equals("")) {
					doSearch(text.getText());
				} else {
					nameList.removeAll();
					hitNrL.setText(PUtils.UTF8("STRING_FOUND")
							+ nameList.getItemCount() + " "
							+ PUtils.UTF8("STRING_HITS"));
					persi.clear();
				}
			}
		});
		text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		grpWhereToSearch = new Group(this, SWT.NONE);
		grpWhereToSearch.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 2, 1));
		grpWhereToSearch.setText(PUtils.UTF8("GROUP_SEARCH"));
		grpWhereToSearch.setLayout(new GridLayout(2, false));

		nameRB = new Button(grpWhereToSearch, SWT.RADIO);
		nameRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "name";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		nameRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, true, 1, 1));
		nameRB.setText(PUtils.UTF8("RADIO_NAMES"));

		emailRB = new Button(grpWhereToSearch, SWT.RADIO);
		emailRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "email";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		emailRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, true, 1, 1));
		emailRB.setText(PUtils.UTF8("RADIO_EMAILS"));

		placeRB = new Button(grpWhereToSearch, SWT.RADIO);
		placeRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "place";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		placeRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, true, 1, 1));
		placeRB.setText(PUtils.UTF8("RADIO_PLACES"));

		addressRB = new Button(grpWhereToSearch, SWT.RADIO);
		addressRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "address";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		addressRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, true, 1,
				1));
		addressRB.setText(PUtils.UTF8("RADIO_ADDRESS"));

		zipRB = new Button(grpWhereToSearch, SWT.RADIO);
		zipRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "zip";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		zipRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, true, 1, 1));
		zipRB.setText(PUtils.UTF8("RADIO_ZIP"));

		numberRB = new Button(grpWhereToSearch, SWT.RADIO);
		numberRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "phone";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		numberRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, true, 1,
				1));
		numberRB.setText(PUtils.UTF8("RADIO_NUMBERS"));

		websiteRB = new Button(grpWhereToSearch, SWT.RADIO);
		websiteRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "website";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		websiteRB.setText(PUtils.UTF8("RADIO_WEBSITES"));

		countryRB = new Button(grpWhereToSearch, SWT.RADIO);
		countryRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "country";
				combo.setEnabled(false);
			}
		});
		countryRB.setText(PUtils.UTF8("RADIO_COUNTRY"));

		btnRadioButton = new Button(grpWhereToSearch, SWT.RADIO);
		btnRadioButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "category";
				combo.setEnabled(true);
			}
		});
		btnRadioButton.setText(PUtils.UTF8("RADIO_CATEGORY"));

		combo = new Combo(grpWhereToSearch, SWT.READ_ONLY);
		combo.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				searchByGroups();

			}
		});
		combo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1,
				1));
		combo.setEnabled(false);
		for (Two t : connection.getCategories()) {
			combo.add(t.getName());
		}
		if (combo.getItemCount() > 0)
			combo.select(0);
		new Label(grpWhereToSearch, SWT.NONE);

		entireRB = new Button(grpWhereToSearch, SWT.RADIO);
		entireRB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1,
				1));
		entireRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				oszlop = "*";
				combo.setEnabled(false);
				text.setFocus();
			}
		});
		entireRB.setSelection(true);
		entireRB.setText(PUtils.UTF8("RADIO_ENTIRE"));

		composite = new Composite(this, SWT.NONE);
		composite.setLayout(new GridLayout(2, true));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2,
				1));

		lblNewLabel_3 = new Label(composite, SWT.NONE);
		lblNewLabel_3.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true,
				false, 1, 1));
		lblNewLabel_3.setSize(62, 15);
		lblNewLabel_3.setText(PUtils.UTF8("LABEL_HITS"));

		lblNewLabel_2 = new Label(composite, SWT.NONE);
		lblNewLabel_2.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true,
				false, 1, 1));
		lblNewLabel_2.setSize(62, 15);
		lblNewLabel_2.setText(PUtils.UTF8("LABEL_DETAILS"));

		nameList = new List(composite, SWT.BORDER | SWT.V_SCROLL);
		nameList.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Person m = persi.get(nameList.getSelectionIndex());
				dataList.removeAll();
				dataList.add(m.getName());
				dataList.add(m.getTele());
				dataList.add(m.getAddress());
				dataList.add(m.getZIP());
				dataList.add(m.getPlace());
				dataList.add(m.getMail());
				dataList.add(m.getWebsite());
				dataList.add(PUtils.codeToCountry(m.getCountry()));
				if (booklet) {
					if (!namer.contains(nameList.getSelectionIndex())) {// Preventing
																		// the
						// duplicated records
						namer.add(nameList.getSelectionIndex());
						order += 1;
						sb.append(order + ". " + m.getName() + "\n");
						sb.append(m.getTele() + "\n");
						sb.append(m.getAddress() + "\n");
						sb.append(m.getZIP() + "\n");
						sb.append(m.getPlace() + "\n");
						sb.append(m.getMail() + "\n");
						sb.append(m.getWebsite() + "\n");
						sb.append(PUtils.codeToCountry(m.getCountry()) + "\n");
						sb.append("\n");
					}
				}
			}
		});
		nameList.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1));

		menu = new Menu(nameList);
		nameList.setMenu(menu);

		mntmNewItem = new MenuItem(menu, SWT.NONE);
		mntmNewItem.addSelectionListener(new SelectionAdapter() {
			@Override
			// Edit the selected contact
			public void widgetSelected(SelectionEvent e) {
				if (nameList.getSelectionIndex() != -1) {
					px = persi.get(nameList.getSelectionIndex());
					shell.setVisible(false);
					Editor.go(connection, px);
					shell.dispose();

				}
			}
		});
		mntmNewItem.setText(PUtils.UTF8("MENU_EDIT"));

		mntmNewItem_1 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_1.addSelectionListener(new SelectionAdapter() {
			@Override
			// Show the selected contact in the main window
			public void widgetSelected(SelectionEvent e) {
				if (nameList.getSelectionIndex() > -1) {
					AppWin.setSString(text.getText());// ! WARNING -> Setting
														// the searchstring
														// memory
					px = persi.get(nameList.getSelectionIndex());
					shell.dispose();
				}
			}
		});
		mntmNewItem_1.setText(PUtils.UTF8("MENU_SHOW_IN_MAIN"));

		mntmNewItem_2 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_2.addSelectionListener(new SelectionAdapter() {
			@Override
			// Create a booklet of selected persons
			public void widgetSelected(SelectionEvent e) {
				if (persi.size() > 0) {
					shell.setVisible(false);
					Printing.main(connection, persi);
					shell.dispose();
				}
			}
		});
		mntmNewItem_2.setText(PUtils.UTF8("MENU_BOOKLET_LIST"));

		mntmNewItem_3 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_3.addSelectionListener(new SelectionAdapter() {
			@Override
			// Export hits to .CSV file
			public void widgetSelected(SelectionEvent e) {
				int ic = nameList.getItemCount();
				Person p = null;
				if (ic > 0) {
					sb = new StringBuffer();
					for (int i = 0; i < ic; ++i) {
						p = persi.get(i);
						sb.append(p.getName() + ";"
								+ (p.getTele()).replace(";", ",") + ";"
								+ p.getAddress() + ";" + p.getPlace() + ";"
								+ p.getZIP() + ";" + p.getMail() + ";"
								+ p.getWebsite() + ";"
								+ PUtils.codeToCountry(p.getCountry()) + "\n");
					}
					doSaveTheBooklet("Hits", ".csv");
				}
			}
		});
		mntmNewItem_3.setText(PUtils.UTF8("MENU_HITS_CSV"));

		mntmNewItem_4 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_4.addSelectionListener(new SelectionAdapter() {
			@Override
			// Export the entire database into a .CSV file
			public void widgetSelected(SelectionEvent e) {
				sb = new StringBuffer();
				ArrayList<Person> ps = null;
				ps = connection.getAll();
				for (Person p : ps) {
					sb.append(p.getName() + ";"
							+ (p.getTele()).replace(";", ",") + ";"
							+ p.getAddress() + ";" + p.getPlace() + ";"
							+ p.getZIP() + ";" + p.getMail() + ";"
							+ p.getWebsite() + ";"
							+ PUtils.codeToCountry(p.getCountry()) + "\n");
				}
				doSaveTheBooklet("Phonebook", ".csv");
			}
		});
		mntmNewItem_4.setText(PUtils.UTF8("MENU_DB_CSV"));

		mntmNewItem_5 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_5.addSelectionListener(new SelectionAdapter() {
			@Override
			// Create a Vcard of a selected contact
			public void widgetSelected(SelectionEvent e) {
				if (nameList.getSelectionIndex() != -1) {
					Person ps = null;
					ps = connection.findID(persi.get(
							nameList.getSelectionIndex()).getID());
					sb = PUtils.vCard(ps);
					doSaveTheBooklet("Vcard for " + ps.getName(), ".vcf");
					bookletCB.setSelection(false);
				}
			}
		});
		mntmNewItem_5.setText(PUtils.UTF8("MENU_VCARD"));

		envelopeMenu = new MenuItem(menu, SWT.NONE);
		envelopeMenu.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if (nameList.getSelectionIndex() > -1) {
					px = persi.get(nameList.getSelectionIndex());
					createEnvelope((Person) px, "LETTER");
				}
			}
		});
		envelopeMenu.setText(PUtils.UTF8("STRING_ENVELOPE"));

		mntmNewItem_6 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_6.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if (nameList.getSelectionIndex() > -1) {
					px = persi.get(nameList.getSelectionIndex());
					createEnvelope((Person) px, "VIP");
				}
			}
		});
		mntmNewItem_6.setText(PUtils.UTF8("STRING_PRINT_CARD"));

		mntmNewItem_7 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_7.addSelectionListener(new SelectionAdapter() {
			@Override
			// Create an IDCard draft in SVG
			public void widgetSelected(SelectionEvent e) {
				SVGSkeleton sk = new SVGSkeleton();
				px = persi.get(nameList.getSelectionIndex());
				sk.createSVG((Person) px, "VIP");
			}
		});
		mntmNewItem_7.setText(PUtils.UTF8("STRING_SVG_CARD"));

		mntmNewItem_8 = new MenuItem(menu, SWT.NONE);
		mntmNewItem_8.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				SVGSkeleton sk = new SVGSkeleton();
				px = persi.get(nameList.getSelectionIndex());
				sk.createSVG((Person) px, "POST");
			}
		});
		mntmNewItem_8.setText(PUtils.UTF8("STRING_ENVELOPE_PRINT"));

		dataList = new List(composite, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		dataList.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1));

		bookletCB = new Button(this, SWT.CHECK);
		bookletCB.setToolTipText(PUtils.UTF8("TOOLTIP_BOOKLET_CHECKBOX"));
		bookletCB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true,
				1, 1));
		bookletCB.addSelectionListener(new SelectionAdapter() {
			@Override
			// Switch between booklet creationary and normal mode
			public void widgetSelected(SelectionEvent e) {
				booklet = bookletCB.getSelection();
				sb = new StringBuffer();// Changed
				if (!booklet) {
					order = 0;
					namer = new ArrayList<>();
				}
			}
		});
		bookletCB.setText(PUtils.UTF8("CHECK_BOOKLET"));

		printListB = new Button(this, SWT.NONE);
		printListB.addMouseListener(new MouseAdapter() {
			@Override
			// Save the customly created booklet as a txt file
			public void mouseUp(MouseEvent e) {
				if (bookletCB.getSelection() && sb.length() > 0) {
					doSaveTheBooklet("Booklet", ".txt");
				}
			}
		});
		printListB.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, true,
				1, 1));
		printListB.setImage(PUtils.getImage(this, "png/phone-book.png"));
		printListB.setToolTipText(PUtils.UTF8("BUTTON_PRINT_BOOKLET"));

		hitNrL = new Label(this, SWT.NONE);
		hitNrL.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));

		composite_1 = new Composite(this, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_1.setLayout(new GridLayout(2, false));

		detailsB = new Button(composite_1, SWT.NONE);
		detailsB.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false,
				1, 1));
		detailsB.addMouseListener(new MouseAdapter() {
			@Override
			// Copy details of the selected contact
			public void mouseUp(MouseEvent e) {
				StringBuffer xd = new StringBuffer();
				for (int i = 0; i < dataList.getItemCount() - 1; ++i) {
					xd.append(dataList.getItem(i) + "\n");
				}
				xd.append("\n");
				StringSelection stringSelection = new StringSelection(xd
						.toString());
				Clipboard clpbrd = Toolkit.getDefaultToolkit()
						.getSystemClipboard();
				clpbrd.setContents(stringSelection, null);
			}
		});
		detailsB.setImage(PUtils.getImage(this, "png/document.png"));
		detailsB.setToolTipText(PUtils.UTF8("BUTTON_DETAIL_COPY"));

		btnNewButton = new Button(composite_1, SWT.NONE);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			// Compose message to different peoples
			public void mouseUp(MouseEvent e) {
				Mailer g = new Mailer(shell, connection);
				g.open();

			}
		});
		btnNewButton.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				false, 1, 1));
		btnNewButton.setImage(PUtils.getImage(this, "png/paper-message.png"));
		btnNewButton.setToolTipText(PUtils.UTF8("BUTTON_BATCH_EMAIL"));

		closeB = new Button(this, SWT.NONE);
		closeB.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				AppWin.setSString(text.getText());// ! WARNING
				shell.dispose();
			}
		});
		closeB.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, true, 1,
				1));
		closeB.setImage(PUtils.getImage(this, "png/arrow-big-01.png"));
		closeB.setToolTipText(PUtils.UTF8("BUTTON_CLOSE"));
		String s = AppWin.getSString();// ! WARNING
		if (!s.equals(""))
			text.setText(s);
		text.setSelection(0, text.getText().length());
		createContents();
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText(PUtils.UTF8("TITLE_ADVANCED"));
		setSize(390, 560);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	/**
	 * @param Perform
	 *            search through the database using the string s
	 */
	private void doSearch(String s) {
		persi.clear();
		nameList.removeAll();
		dataList.removeAll();
		if (oszlop == "*") {
			persi = connection.findInAll(s);
		} else if (oszlop == "category") {
			persi = connection.findInCategories(s, "QUERY");
		} else {
			persi = connection.findInColumn(s, oszlop);
		}
		for (Person p : persi) {
			nameList.add(p.getName());
		}
		hitNrL.setText(PUtils.UTF8("STRING_FOUND") + nameList.getItemCount()
				+ " " + PUtils.UTF8("STRING_HITS"));
	}

	private void searchByGroups() {
		persi.clear();
		nameList.removeAll();
		dataList.removeAll();
		String a = combo.getText();
		persi = connection.findInCategories(a, "Other");
		for (Person p : persi) {
			nameList.add(p.getName());
		}
		hitNrL.setText(PUtils.UTF8("STRING_FOUND") + nameList.getItemCount()
				+ " " + PUtils.UTF8("STRING_HITS"));
	}

	private void doSaveTheBooklet(String name, String extens) {
		FileDialog dialog = new FileDialog(shell, SWT.SAVE);
		dialog.setFilterNames(new String[] { "Text files" });
		dialog.setFilterExtensions(new String[] { extens });
		dialog.setFilterPath(System.getProperty("user.home"));
		dialog.setFileName(name + extens);
		String x = dialog.open();
		if (x != null) {
			try {
				File f = new File(x);
				PrintStream ps = new PrintStream(new FileOutputStream(f));
				ps.print(sb);
				ps.close();
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

	}

	public static void createEnvelope(Person p, String mode) {
		xcard = null;
		@SuppressWarnings("unused")
		Rectangle clientArea = null;
		PrintDialog dialog = new PrintDialog(shell);
		PrinterData printerData = dialog.open();
		if (printerData != null) {
			Printer printer = new Printer(printerData);
			clientArea = shell.getClientArea();
			if (mode.equals("VIP")) {
				xcard = p.getName() + "\n" + p.getAddress() + "\n" + p.getZIP()
						+ " " + p.getPlace() + "\n"
						+ PUtils.codeToCountry(p.getCountry());
				if (p.getNumber().size() > 0)
					xcard = xcard + "\n" + "Tel: "
							+ p.getNumber(new TripletFormatter()).get(0);
				if (p.getEmail().size() > 0)
					xcard = xcard + "\n" + "E-mail: " + p.getEmail().get(0);

			} else {

				xcard = p.getName() + "\n" + p.getAddress() + "\n" + p.getZIP()
						+ " " + p.getPlace() + "\n"
						+ PUtils.codeToCountry(p.getCountry());
			}

			printerData.orientation = PrinterData.PORTRAIT;
			Point dpi = printer.getDPI();
			if (printer.startJob(p.getName())) {
				GC gc = new GC(printer);
				if (printer.startPage()) {
					int cm = (int) (dpi.x / 2.54);
					gc.drawRectangle((int) (0.5 * cm), (int) (0.5 * cm),
							8 * cm, 3 * cm);
					Font font = new Font(Display.getCurrent(), "Arial", 30,
							SWT.BOLD | SWT.ITALIC);
					gc.setFont(font);
					gc.drawText(xcard, (int) (0.9 * cm), (int) (0.9 * cm));
					printer.endPage();
				}
				gc.dispose();
				printer.endJob();
				printer.dispose();
			}
		}

	}
}
