package phonix;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.util.ArrayList;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Link;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.events.MenuAdapter;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.ModifyEvent;

public class AppWin {
	protected Shell shlPhonixJ;
	private Label lblNewLabel;
	private Combo combo;
	private Text text;
	private List list;
	private Label lblNewLabel_1;
	private Label lblNewLabel_2;
	private Text addressT;
	private Label lblNewLabel_3;
	private Text placeT;
	private Label lblNewLabel_4;
	private Button copyMailB;
	private Label lblNewLabel_6;
	private Text contNr;
	private Button btnNewButton;
	private Button btnNewButton_1;
	private Button btnNewButton_2;
	private Button btnNewButton_3;
	private Button btnNewButton_5;
	private Label lblNewLabel_7;
	private static DatabaseConnector connection;
	private Label lblNewLabel_8;
	private List numberL;
	private Link websiteT;
	private static Display display;
	private static String fullweblink = "";
	private Button btnNewButton_4;
	private Group group;
	private static String sstring = "";
	private static ScrolledComposite emailCo;
	private static ComboCheckbox combocheck = null;
	public static ArrayList<Integer> comboID = new ArrayList<>();
	private Label lblNewLabel_9;
	private Composite composite;
	private Composite composite_1;
	private Composite composite_2;
	private Composite composite_3;
	private Composite composite_4;
	private Composite composite_5;
	private Composite composite_6;
	private Composite composite_7;
	private Composite composite_8;
	private Composite composite_9;
	private ArrayList<Button> ems = new ArrayList<>();
	private Text zipT;
	private Composite composite_10;
	private Label quickNr;
	private Label lblNewLabel_5;
	private Composite composite_11;
	private Label countryT;
	private ArrayList<Two> categories = new ArrayList<>();
	private ArrayList<String> groups = new ArrayList<>();
	private static String stext;
	private Menu menu;
	private static Person menuperson;
	private Button btnNewButton_6;

	public static void setSString(String s) {
		sstring = s;
	}

	public static String getSString() {
		return sstring;
	}

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static void fire() {
		connection = new DatabaseConnector();
		try {

			AppWin window = new AppWin();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		display = Display.getDefault();
		createContents();
		fillNames();
		shlPhonixJ.open();
		shlPhonixJ.layout();
		while (!shlPhonixJ.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}

		}
	}

	/**
	 * Create contents of the window.
	 * 
	 * @wbp.parser.entryPoint
	 */
	protected void createContents() {
		shlPhonixJ = new Shell();

		shlPhonixJ.setImage(PUtils.getImage(this, "png/phonixj.png"));
		shlPhonixJ.setSize(345, 730);
		shlPhonixJ.setText("PhonixJ");
		shlPhonixJ.setLocation(
				(Display.getCurrent().getBounds().width - shlPhonixJ
						.getBounds().width) / 2,
				(Display.getCurrent().getBounds().height - shlPhonixJ
						.getBounds().height) / 2);
		GridData gd3 = new GridData(SWT.FILL, SWT.FILL, true, false, 2, 3);
		gd3.heightHint = 305;
		shlPhonixJ.setLayoutData(gd3);
		shlPhonixJ.setLayout(new GridLayout(1, false));

		composite = new Composite(shlPhonixJ, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false,
				1, 1));
		composite.setLayout(new GridLayout(3, false));
		lblNewLabel = new Label(composite, SWT.NONE);
		lblNewLabel.setText(PUtils.UTF8("LABEL_NAME"));

		combo = new Combo(composite, SWT.READ_ONLY);
		combo.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				int x = combo.getSelectionIndex();
				if (x > -1) {
					Person persi = connection.findID(comboID.get(x));
					setData(persi);
				}
			}
		});

		combo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		combo.setVisibleItemCount(8);

		combo.addKeyListener(new ComboAdapter(combo));
		// When a person is selected from the combo
		combo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				int x = combo.getSelectionIndex();
				Person persi = connection.findID(comboID.get(x));
				setData(persi);
			}

		});

		composite_1 = new Composite(shlPhonixJ, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false,
				1, 1));
		composite_1.setLayout(new GridLayout(4, false));

		lblNewLabel_7 = new Label(composite_1, SWT.NONE);
		lblNewLabel_7.setText(PUtils.UTF8("LABEL_QUICK"));

		text = new Text(composite_1, SWT.BORDER | SWT.SEARCH);
		text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));

		quickNr = new Label(composite_1, SWT.BORDER);
		GridData gd_quickNr = new GridData(SWT.RIGHT, SWT.CENTER, false, true,
				1, 1);
		gd_quickNr.minimumWidth = -1;
		quickNr.setLayoutData(gd_quickNr);
		quickNr.setText("0");
		text.addKeyListener(new KeyAdapter() {
			@Override
			// The text of quicksearch is changed
			public void keyReleased(KeyEvent e) {
				if (e.keyCode != 16777218 && !text.getText().equals("")) {
					searchEvent(text.getText());
				} else if (e.keyCode != 16777218 && text.getText().equals("")) {
					list.removeAll();
				} else {
					list.select(0);
					list.setFocus();

				}
				quickNr.setText(String.valueOf(list.getItemCount()));
				quickNr.getParent().layout();
			}

		});

		list = new List(shlPhonixJ, SWT.BORDER | SWT.V_SCROLL);
		list.setToolTipText(PUtils.UTF8("TOOLTIP_CATEGORIES"));
		list.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		list.addSelectionListener(new SelectionAdapter() {
			@Override
			// An item is selected in hit's list
			public void widgetSelected(SelectionEvent e) {
				String name = list.getItem(list.getSelectionIndex());
				combo.select(combo.indexOf(name));
				Person persi = connection.findID(comboID.get(combo
						.indexOf(name)));
				setData(persi);
				list.setFocus();
			}
		});

		menu = new Menu(list);
		menu.addMenuListener(new MenuAdapter() {
			@Override
			public void menuShown(MenuEvent e) {
				if (list.getItemCount() > 0 && list.getSelectionIndex() > -1) {
					String name = list.getItem(list.getSelectionIndex());
					menuperson = connection.findID(comboID.get(combo
							.indexOf(name)));
					categories = connection.getCategories();
					groups = connection.getGroups(menuperson.getID());
					MenuItem m = null;

					for (MenuItem xd : menu.getItems())
						xd.dispose();

					for (int i = 0; i < categories.size(); ++i) {
						stext = categories.get(i).getName();
						m = new MenuItem(menu, SWT.CHECK);
						if (groups.indexOf(stext) > -1) {
							m.setSelection(true);
						}
						m.addSelectionListener(new SelectionAdapter() {
							@Override
							public void widgetSelected(SelectionEvent e) {
								MenuItem[] qw = menu.getItems();
								for (MenuItem x : qw) {
									if (x.getSelection()) {
										connection.insertIntoGroup(
												menuperson.getID(), x.getText());
									} else {
										connection.removeFromGroup(
												menuperson.getID(), x.getText());
									}

								}
							}

						});
						m.setText(stext);
					}

				}
			}

		});
		list.setMenu(menu);
		group = new Group(shlPhonixJ, SWT.NONE);
		group.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1,
				1));
		group.setLayout(new GridLayout(3, false));

		lblNewLabel_1 = new Label(group, SWT.NONE);
		lblNewLabel_1.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false,
				true, 1, 1));
		lblNewLabel_1.setText(PUtils.UTF8("LABEL_NUMBER"));

		numberL = new List(group, SWT.BORDER | SWT.V_SCROLL);
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 3);
		gd.heightHint = 40;
		numberL.setLayoutData(gd);

		new Label(group, SWT.NONE);
		new Label(group, SWT.NONE);

		composite_2 = new Composite(shlPhonixJ, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_2.setLayout(new GridLayout(3, false));

		lblNewLabel_2 = new Label(composite_2, SWT.NONE);
		lblNewLabel_2.setText(PUtils.UTF8("LABEL_ADDRESS"));

		addressT = new Text(composite_2, SWT.BORDER | SWT.READ_ONLY);
		addressT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2,
				1));

		composite_3 = new Composite(shlPhonixJ, SWT.NONE);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_3.setLayout(new GridLayout(3, false));

		lblNewLabel_3 = new Label(composite_3, SWT.NONE);
		lblNewLabel_3.setText(PUtils.UTF8("LABEL_PLACE"));

		placeT = new Text(composite_3, SWT.BORDER | SWT.READ_ONLY);
		placeT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));

		composite_4 = new Composite(shlPhonixJ, SWT.NONE);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_4.setLayout(new GridLayout(2, false));

		lblNewLabel_4 = new Label(composite_4, SWT.NONE);
		lblNewLabel_4.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		lblNewLabel_4.setText(PUtils.UTF8("LABEL_ZIP"));

		zipT = new Text(composite_4, SWT.BORDER);
		zipT.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		composite_5 = new Composite(shlPhonixJ, SWT.NONE);
		GridData gd_composite_5 = new GridData(SWT.FILL, SWT.TOP, true, false,
				1, 1);
		gd_composite_5.minimumHeight = 35;
		gd_composite_5.heightHint = 45;
		composite_5.setLayoutData(gd_composite_5);
		composite_5.setLayout(new GridLayout(3, false));

		lblNewLabel_9 = new Label(composite_5, SWT.NONE);
		GridData gd_lblNewLabel_9 = new GridData(SWT.LEFT, SWT.CENTER, false,
				false, 1, 1);
		gd_lblNewLabel_9.heightHint = 40;
		lblNewLabel_9.setLayoutData(gd_lblNewLabel_9);
		lblNewLabel_9.setText("Email:");

		composite_10 = new Composite(composite_5, SWT.NONE);
		GridData gd_composite_10 = new GridData(SWT.LEFT, SWT.CENTER, true,
				false, 1, 1);
		gd_composite_10.heightHint = 40;
		composite_10.setLayoutData(gd_composite_10);

		copyMailB = new Button(composite_5, SWT.NONE);
		GridData gd_copyMailB = new GridData(SWT.FILL, SWT.FILL, false, false,
				1, 1);
		gd_copyMailB.heightHint = 40;
		copyMailB.setLayoutData(gd_copyMailB);
		copyMailB.setToolTipText(PUtils.UTF8("TOOLTIP_COPY"));
		copyMailB.addMouseListener(new MouseAdapter() {
			@Override
			// Copy the email and send a mail - Development!
			public void mouseUp(MouseEvent e) {

				String t = "";
				for (Button b : ems) {
					if (b.getSelection()) {
						t += b.getText() + ",";
					}
				}
				if (t.length() > 0) {
					t = t.substring(0, t.length() - 1);
					if (!t.equals("-") && !t.equals("")) {

						StringSelection stringSelection = new StringSelection(t);
						Clipboard clpbrd = Toolkit.getDefaultToolkit()
								.getSystemClipboard();
						clpbrd.setContents(stringSelection, null);
						Program.launch("mailto:" + t);
					}
				}
			}

		});
		copyMailB.setImage(PUtils.getImage(this, "png/email.png"));
		copyMailB.setToolTipText(PUtils.UTF8("BUTTON_COPY"));
		emailCo = new ScrolledComposite(shlPhonixJ, SWT.NONE);
		GridData gd_emailCo = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_emailCo.minimumHeight = 65;
		emailCo.setLayoutData(gd_emailCo);
		emailCo.setLayout(new GridLayout(1, false));
		emailCo.setExpandHorizontal(true);
		emailCo.setExpandVertical(true);

		composite_6 = new Composite(shlPhonixJ, SWT.NONE);
		composite_6.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_6.setLayout(new GridLayout(3, false));

		lblNewLabel_8 = new Label(composite_6, SWT.NONE);
		lblNewLabel_8.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false,
				false, 1, 1));
		lblNewLabel_8.setText(PUtils.UTF8("LABEL_WEBSITE"));

		websiteT = new Link(composite_6, SWT.NONE);
		websiteT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2,
				1));
		websiteT.addMouseTrackListener(new MouseTrackAdapter() {
			@Override
			public void mouseEnter(MouseEvent e) {
				shlPhonixJ.setCursor(display.getSystemCursor(SWT.CURSOR_HAND));
			}

			@Override
			public void mouseExit(MouseEvent e) {
				shlPhonixJ.setCursor(display.getSystemCursor(SWT.CURSOR_ARROW));
			}
		});
		websiteT.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		websiteT.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if (!websiteT.getText().equals(""))
					Program.launch(fullweblink);

			}
		});
		websiteT.setText("<a></a>");

		composite_7 = new Composite(shlPhonixJ, SWT.NONE);
		composite_7.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_7.setLayout(new GridLayout(4, false));

		btnNewButton_6 = new Button(composite_7, SWT.NONE);
		btnNewButton_6.setToolTipText(PUtils.UTF8("TOOLTIP_NOTES"));
		btnNewButton_6.setImage(SWTResourceManager.getImage(AppWin.class,
				"/png/sketch.png"));
		btnNewButton_6.addMouseListener(new MouseAdapter() {
			@Override
			// Open Notes dialog
			public void mouseUp(MouseEvent e) {
				if (combo.getItemCount() > 0) {
					int curname = combo.getSelectionIndex();

					Person px = connection.findID(comboID.get(curname));
					Notes n = new Notes(shlPhonixJ, connection, px.getID(), px
							.getName());
					n.open();

				}

			}
		});

		lblNewLabel_6 = new Label(composite_7, SWT.NONE);
		lblNewLabel_6.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true,
				true, 2, 1));
		lblNewLabel_6.setText(PUtils.UTF8("LABEL_RECORDS"));

		contNr = new Text(composite_7, SWT.BORDER | SWT.READ_ONLY);
		contNr.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false,
				1, 1));

		composite_11 = new Composite(shlPhonixJ, SWT.NONE);
		GridData gd_composite_11 = new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1);
		gd_composite_11.minimumHeight = 25;
		composite_11.setLayoutData(gd_composite_11);
		composite_11.setLayout(new GridLayout(2, false));

		lblNewLabel_5 = new Label(composite_11, SWT.NONE);
		lblNewLabel_5.setText(PUtils.UTF8("LABEL_COUNTRY"));

		countryT = new Label(composite_11, SWT.NONE);
		countryT.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, false,
				1, 1));

		composite_8 = new Composite(shlPhonixJ, SWT.NONE);
		composite_8.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_8.setLayout(new GridLayout(3, false));

		btnNewButton = new Button(composite_8, SWT.NONE);
		btnNewButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			// Add a new contact
			public void mouseUp(MouseEvent e) {
				shlPhonixJ.setVisible(false);
				Humanoid person = AddNew.main(connection);
				if (!(person instanceof NullPerson)) {
					contNr.setText(connection.insertPerson((Person) person));
				}
				shlPhonixJ.setVisible(true);
				fillNames();
			}
		});
		btnNewButton.setImage(PUtils.getImage(this, "png/plus-sign.png"));
		btnNewButton.setToolTipText(PUtils.UTF8("BUTTON_ADD"));

		btnNewButton_1 = new Button(composite_8, SWT.NONE);
		btnNewButton_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 1, 1));
		btnNewButton_1.addMouseListener(new MouseAdapter() {
			@Override
			// Search in the database - possible errors!
			public void mouseUp(MouseEvent e) {
				shlPhonixJ.setVisible(false);
				Humanoid gog = Searcher.go(connection, combo.getText());
				if (!(gog instanceof NullPerson)) {
					Person repname = (Person) gog;
					for (int x = 0; x < combo.getItemCount(); ++x) {
						if (combo.getItem(x).equals(repname.getName())) {
							combo.select(x);
							break;
						}
					}
					setData(repname);
				}

				shlPhonixJ.setVisible(true);
				combo.setFocus();
			}
		});
		btnNewButton_1.setImage(PUtils.getImage(this, "png/search.png"));
		btnNewButton_1.setToolTipText(PUtils.UTF8("BUTTON_SEARCH"));

		btnNewButton_2 = new Button(composite_8, SWT.NONE);
		btnNewButton_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 1, 1));
		btnNewButton_2.addMouseListener(new MouseAdapter() {
			@Override
			// Edit the selected contact
			public void mouseUp(MouseEvent e) {
				if (combo.getItemCount() > 0) {
					int curname = combo.getSelectionIndex();

					Person px = connection.findID(comboID.get(curname));
					shlPhonixJ.setVisible(false);
					boolean b = Editor.go(connection, px);
					if (b) {
						fillNames();
						cleanFrames();
						if (comboID.size() > 0) {
							px = connection.findID(comboID.get(curname));
							if (px != null) {// the person exist
								combo.select(combo.indexOf(px.getName()));
								setData(px);
							}
						}

					}
					list.removeAll();
					shlPhonixJ.setVisible(true);

				}
			}
		});
		btnNewButton_2.setImage(PUtils.getImage(this, "png/pen.png"));
		btnNewButton_2.setToolTipText(PUtils.UTF8("BUTTON_EDIT"));

		composite_9 = new Composite(shlPhonixJ, SWT.NONE);
		composite_9.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		composite_9.setLayout(new GridLayout(3, false));

		btnNewButton_3 = new Button(composite_9, SWT.NONE);
		btnNewButton_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 1, 1));
		btnNewButton_3.setToolTipText(PUtils.UTF8("TOOLTIP_PRINT"));
		btnNewButton_3.addMouseListener(new MouseAdapter() {
			@Override
			// Print the booklet
			public void mouseUp(MouseEvent e) {

				int k = connection.getContacts().size();
				if (k > 0) {
					shlPhonixJ.setVisible(false);
					Printing.main(connection, null);
					shlPhonixJ.setVisible(true);
				}
			}
		});
		btnNewButton_3.setImage(PUtils.getImage(this, "png/printer.png"));

		btnNewButton_4 = new Button(composite_9, SWT.NONE);
		btnNewButton_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 1, 1));
		btnNewButton_4.addMouseListener(new MouseAdapter() {
			@Override
			// Repair the database
			public void mouseUp(MouseEvent e) {
				shlPhonixJ.setVisible(false);
				boolean b = Repair.main(connection);
				if (b) {
					cleanFrames();
					fillNames();
					if (combo.getItemCount() > 0) {
						Person p = connection.findID(comboID.get(0));
						setData(p);
					}
				}
				shlPhonixJ.setVisible(true);
			}
		});
		btnNewButton_4.setToolTipText(PUtils.UTF8("TOOLTIP_REPAIR"));
		btnNewButton_4.setImage(PUtils.getImage(this, "png/spanner.png"));

		btnNewButton_5 = new Button(composite_9, SWT.NONE);
		btnNewButton_5.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 1, 1));
		btnNewButton_5.addMouseListener(new MouseAdapter() {
			@Override
			// Quit the application
			public void mouseUp(MouseEvent e) {
				shlPhonixJ.dispose();
			}
		});
		btnNewButton_5.setImage(PUtils.getImage(this, "png/power-button.png"));
		btnNewButton_5.setToolTipText(PUtils.UTF8("BUTTON_QUIT"));
		text.setFocus();
	}

	private void searchEvent(String s) {
		list.removeAll();
		for (Person x : connection.findPerson(s)) {
			list.add(x.getName());
		}
	}

	private void fillNames() {
		connection.fix();
		combo.removeAll();
		comboID.clear();
		Person p = null;
		for (Two s : connection.getContacts()) {
			combo.add(s.getName());
			comboID.add(s.getId());

		}
		if (combo.getItemCount() > 0) {
			combo.select(0);
			p = connection.findID(comboID.get(0));
			setData(p);
		}
		contNr.setText("" + combo.getItemCount());
		combo.setFocus();
	}

	private void setData(Person p) {
		numberL.removeAll();

		for (String x : p.getNumber(new TripletFormatter())) {
			numberL.add(x);
		}
		addressT.setText(p.getAddress());
		placeT.setText(p.getPlace());
		zipT.setText(p.getZIP());
		countryT.setText(PUtils.codeToCountry(p.getCountry()));
		countryT.getParent().layout();
		if (!p.getWebsite().equals("-")) {
			fullweblink = p.getWebsite();
			String c = p.getWebsite().replace("https://", "");
			c = c.replace("http://", "");
			websiteT.setText(c);

		} else {
			websiteT.setText("");
			fullweblink = "";
		}

		if (combocheck != null) {
			combocheck.dispose();
		}

		ems.clear();
		combocheck = new ComboCheckbox(emailCo, SWT.NONE, p.getEmail(), ems);
		emailCo.setContent(combocheck);
		combo.setFocus();
	}

	private void cleanFrames() {
		websiteT.setText("");
		zipT.setText("");
		placeT.setText("");
		addressT.setText("");
		countryT.setText("");
		numberL.removeAll();
		list.removeAll();
		for (Button b : ems) {
			b.dispose();
		}
	}

}
