package phonix;

import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;

public class InputField extends Composite {
private Label label;
private Text text;
private Button button;
private Composite shell=null;
private String labeltext;
private int maxcount=5;

public String getText(){
	return this.text.getText();
}

public void setTex(String t){
	this.text.setText(t);
}

public  void removeButton(){
	this.button.dispose();
}
	public InputField(final Composite parent,final String t,final Composite xom,final ArrayList<InputField> fields) {
		super(parent, SWT.NONE);
		this.labeltext=t;
		this.shell=xom;
		this.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 3,
				1));
		this.setLayout(new GridLayout(3, false));	
		this.label= new Label(parent, SWT.NONE);
		this.label.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		this.label.setText(labeltext);

		this.text = new Text(parent, SWT.BORDER);
		this.text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,
				1));
		button= new Button(parent, SWT.NONE);
		button.setText("+");
			
		button.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1,
				1));
		button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if(fields.size()<=maxcount){					
				InputField ii=new InputField( parent,t,xom, fields );
				fields.add(ii);
				}else{
					for(InputField t:fields){
						t.button.dispose();
					}
				}
				
			}
		});
		
		fields.add(this);
		this.getParent().layout();
		shell.pack();
	}
	
	

}
